## r-cran-igraph 2.0.3

=== DESCRIPTION ===
Package: igraph
Version: 2.0.3
Title: Network Analysis and Visualization
Authors@R: c(
    person("Gábor", "Csárdi", , "csardi.gabor@gmail.com", role = "aut",
           comment = c(ORCID = "0000-0001-7098-9676")),
    person("Tamás", "Nepusz", , "ntamas@gmail.com", role = "aut",
           comment = c(ORCID = "0000-0002-1451-338X")),
    person("Vincent", "Traag", role = "aut",
           comment = c(ORCID = "0000-0003-3170-3879")),
    person("Szabolcs", "Horvát", , "szhorvat@gmail.com", role = "aut",
           comment = c(ORCID = "0000-0002-3100-523X")),
    person("Fabio", "Zanini", , "fabio.zanini@unsw.edu.au", role = "aut",
           comment = c(ORCID = "0000-0001-7097-8539")),
    person("Daniel", "Noom", role = "aut"),
    person("Kirill", "Müller", , "kirill@cynkra.com", role = c("aut", "cre"),
           comment = c(ORCID = "0000-0002-1416-3412")),
    person("Maëlle", "Salmon", role = "ctb"),
    person("Michael", "Antonov", role = "ctb"),
    person("Chan Zuckerberg Initiative", role = "fnd")
  )
Description: Routines for simple graphs and network analysis. It can
    handle large graphs very well and provides functions for generating
    random and regular graphs, graph visualization, centrality methods and
    much more.
License: GPL (>= 2)
URL: https://r.igraph.org/, https://igraph.org/,
        https://igraph.discourse.group/
BugReports: https://github.com/igraph/rigraph/issues
Depends: methods, R (>= 3.5.0)
Imports: cli, graphics, grDevices, lifecycle, magrittr, Matrix,
        pkgconfig (>= 2.0.0), rlang, stats, utils, vctrs
Suggests: ape (>= 5.7-0.1), callr, decor, digest, graph, igraphdata,
        knitr, rgl, rmarkdown, scales, stats4, tcltk, testthat, vdiffr,
        withr
LinkingTo: cpp11 (>= 0.4.7)
VignetteBuilder: knitr
Config/Needs/build: roxygen2, devtools, irlba, pkgconfig
Config/Needs/coverage: covr
Config/Needs/website: readr
Config/testthat/edition: 3
Config/testthat/parallel: true
Config/testthat/start-first: vs-es, scan, vs-operators, weakref,
        watts.strogatz.game
Encoding: UTF-8
RoxygenNote: 7.3.1
SystemRequirements: libxml2 (optional), glpk (>= 4.57, optional)
NeedsCompilation: yes
Packaged: 2024-03-12 18:19:12 UTC; kirill
Author: Gábor Csárdi [aut] (<https://orcid.org/0000-0001-7098-9676>),
  Tamás Nepusz [aut] (<https://orcid.org/0000-0002-1451-338X>),
  Vincent Traag [aut] (<https://orcid.org/0000-0003-3170-3879>),
  Szabolcs Horvát [aut] (<https://orcid.org/0000-0002-3100-523X>),
  Fabio Zanini [aut] (<https://orcid.org/0000-0001-7097-8539>),
  Daniel Noom [aut],
  Kirill Müller [aut, cre] (<https://orcid.org/0000-0002-1416-3412>),
  Maëlle Salmon [ctb],
  Michael Antonov [ctb],
  Chan Zuckerberg Initiative [fnd]
Maintainer: Kirill Müller <kirill@cynkra.com>
Repository: CRAN
Date/Publication: 2024-03-13 07:30:02 UTC

=== src/vendor/cigraph/src/CMakeLists.txt ===

# Traverse subdirectories
add_subdirectory(centrality/prpack)
add_subdirectory(cliques/cliquer)
add_subdirectory(isomorphism/bliss)

# Generate lexers and parsers
set(PARSER_SOURCES)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/io/parsers)
foreach(FORMAT dl gml lgl ncol pajek)
  if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/io/parsers/${FORMAT}-parser.c)
    list(APPEND PARSER_SOURCES
      ${CMAKE_CURRENT_SOURCE_DIR}/io/parsers/${FORMAT}-lexer.c
      ${CMAKE_CURRENT_SOURCE_DIR}/io/parsers/${FORMAT}-parser.c
    )
  else()
    if (BISON_VERSION VERSION_GREATER_EQUAL 3)
      set(bison_no_deprecated -Wno-deprecated)
    endif()
    if (NOT FLEX_KEEP_LINE_NUMBERS)
      set(bison_hide_line_numbers --no-lines)
      set(flex_hide_line_numbers --noline)
    endif()
    bison_target(
      ${FORMAT}_parser io/${FORMAT}-parser.y ${CMAKE_CURRENT_BINARY_DIR}/io/parsers/${FORMAT}-parser.c
      COMPILE_FLAGS "${bison_hide_line_numbers} ${bison_no_deprecated}"
    )
    flex_target(
      ${FORMAT}_lexer io/${FORMAT}-lexer.l ${CMAKE_CURRENT_BINARY_DIR}/io/parsers/${FORMAT}-lexer.c
      COMPILE_FLAGS "${flex_hide_line_numbers}"
      DEFINES_FILE ${CMAKE_CURRENT_BINARY_DIR}/io/parsers/${FORMAT}-lexer.h
    )
    add_flex_bison_dependency(${FORMAT}_lexer ${FORMAT}_parser)
    list(APPEND PARSER_SOURCES ${BISON_${FORMAT}_parser_OUTPUTS} ${FLEX_${FORMAT}_lexer_OUTPUTS})
  endif()
endforeach()
add_custom_target(parsersources SOURCES ${PARSER_SOURCES})

# Declare the files needed to compile the igraph library
add_library(
  igraph
  core/array.c
  core/buckets.c
  core/cutheap.c
  core/dqueue.c
  core/error.c
  core/estack.c
  core/fixed_vectorlist.c
  core/genheap.c
  core/grid.c
  core/heap.c
  core/indheap.c
  core/interruption.c
  core/marked_queue.c
  core/matrix.c
  core/matrix_list.c
  core/memory.c
  core/printing.c
  core/progress.c
  core/psumtree.c
  core/set.c
  core/sparsemat.c
  core/stack.c
  core/statusbar.c
  core/strvector.c
  core/trie.c
  core/vector.c
  core/vector_list.c
  core/vector_ptr.c

  math/complex.c
  math/safe_intop.c
  math/utils.c

  linalg/arpack.c
  linalg/blas.c
  linalg/eigen.c
  linalg/lapack.c

  random/random.c
  random/rng_glibc2.c
  random/rng_mt19937.c
  random/rng_pcg32.c
  random/rng_pcg64.c

  graph/adjlist.c
  graph/attributes.c
  graph/basic_query.c
  graph/caching.c
  graph/cattributes.c
  graph/graph_list.c
  graph/iterators.c
  graph/type_common.c
  graph/type_indexededgelist.c
  graph/visitors.c

  constructors/adjacency.c
  constructors/atlas.c
  constructors/basic_constructors.c
  constructors/circulant.c
  constructors/de_bruijn.c
  constructors/famous.c
  constructors/full.c
  constructors/generalized_petersen.c
  constructors/kautz.c
  constructors/lattices.c
  constructors/lcf.c
  constructors/linegraph.c
  constructors/prufer.c
  constructors/regular.c
  constructors/trees.c


  games/barabasi.c
  games/callaway_traits.c
  games/citations.c
  games/correlated.c
  games/degree_sequence_vl/gengraph_degree_sequence.cpp
  games/degree_sequence_vl/gengraph_graph_molloy_hash.cpp
  games/degree_sequence_vl/gengraph_graph_molloy_optimized.cpp
  games/degree_sequence_vl/gengraph_mr-connected.cpp
  games/degree_sequence.c
  games/dotproduct.c
  games/erdos_renyi.c
  games/establishment.c
  games/forestfire.c
  games/grg.c
  games/growing_random.c
  games/islands.c
  games/k_regular.c
  games/preference.c
  games/recent_degree.c
  games/sbm.c
  games/static_fitness.c
  games/tree.c
  games/watts_strogatz.c

  centrality/betweenness.c
  centrality/centrality_other.c
  centrality/centralization.c
  centrality/closeness.c
  centrality/coreness.c
  centrality/eigenvector.c
  centrality/hub_authority.c
  centrality/pagerank.c
  centrality/truss.cpp
  centrality/prpack.cpp

  cliques/cliquer_wrapper.c
  cliques/cliques.c
  cliques/maximal_cliques.c
  cliques/glet.c

  community/community_misc.c
  community/edge_betweenness.c
  community/fast_modularity.c
  community/fluid.c
  community/infomap/infomap_FlowGraph.cc
  community/infomap/infomap_Greedy.cc
  community/infomap/infomap.cc
  community/label_propagation.c
  community/leading_eigenvector.c
  community/leiden.c
  community/louvain.c
  community/modularity.c
  community/optimal_modularity.c
  community/spinglass/clustertool.cpp
  community/spinglass/NetDataTypes.cpp
  community/spinglass/NetRoutines.cpp
  community/spinglass/pottsmodel_2.cpp
  community/voronoi.c
  community/walktrap/walktrap_communities.cpp
  community/walktrap/walktrap_graph.cpp
  community/walktrap/walktrap_heap.cpp
  community/walktrap/walktrap.cpp

  connectivity/cohesive_blocks.c
  connectivity/components.c
  connectivity/separators.c

  flow/flow.c
  flow/flow_conversion.c
  flow/st-cuts.c

  hrg/hrg_types.cc
  hrg/hrg.cc

  io/dimacs.c
  io/dl.c
  io/dot.c
  io/edgelist.c
  io/graphml.c
  io/gml-tree.c
  io/gml.c
  io/graphdb.c
  io/leda.c
  io/lgl.c
  io/ncol.c
  io/pajek.c
  io/parse_utils.c
  ${PARSER_SOURCES}

  layout/circular.c
  layout/davidson_harel.c
  layout/drl/DensityGrid.cpp
  layout/drl/DensityGrid_3d.cpp
  layout/drl/drl_graph.cpp
  layout/drl/drl_graph_3d.cpp
  layout/drl/drl_layout.cpp
  layout/drl/drl_layout_3d.cpp
  layout/fruchterman_reingold.c
  layout/gem.c
  layout/graphopt.c
  layout/kamada_kawai.c
  layout/large_graph.c
  layout/layout_bipartite.c
  layout/layout_grid.c
  layout/layout_random.c
  layout/mds.c
  layout/merge_dla.c
  layout/merge_grid.c
  layout/reingold_tilford.c
  layout/sugiyama.c
  layout/umap.c

  operators/add_edge.c
  operators/complementer.c
  operators/compose.c
  operators/connect_neighborhood.c
  operators/contract.c
  operators/difference.c
  operators/disjoint_union.c
  operators/intersection.c
  operators/join.c
  operators/misc_internal.c
  operators/permute.c
  operators/reverse.c
  operators/rewire.c
  operators/rewire_edges.c
  operators/simplify.c
  operators/subgraph.c
  operators/union.c

  paths/all_shortest_paths.c
  paths/astar.c
  paths/bellman_ford.c
  paths/dijkstra.c
  paths/distances.c
  paths/eulerian.c
  paths/floyd_warshall.c
  paths/histogram.c
  paths/johnson.c
  paths/random_walk.c
  paths/shortest_paths.c
  paths/simple_paths.c
  paths/sparsifier.c
  paths/unweighted.c
  paths/voronoi.c
  paths/widest_paths.c

  properties/basic_properties.c
  properties/complete.c
  properties/constraint.c
  properties/convergence_degree.c
  properties/dag.c
  properties/degrees.c
  properties/ecc.c
  properties/girth.c
  properties/loops.c
  properties/multiplicity.c
  properties/neighborhood.c
  properties/perfect.c
  properties/spectral.c
  properties/trees.c
  properties/triangles.c

  isomorphism/bliss.cc
  isomorphism/isoclasses.c
  isomorphism/lad.c
  isomorphism/isomorphism_misc.c
  isomorphism/queries.c
  isomorphism/vf2.c

  misc/bipartite.c
  misc/chordality.c
  misc/cocitation.c
  misc/coloring.c
  misc/conversion.c
  misc/cycle_bases.c
  misc/degree_sequence.cpp
  misc/embedding.c
  misc/feedback_arc_set.c
  misc/graphicality.c
  misc/matching.c
  misc/microscopic_update.c
  misc/mixing.c
  misc/motifs.c
  misc/order_cycle.cpp
  misc/other.c
  misc/power_law_fit.c
  misc/scan.c
  misc/sir.c
  misc/spanning_trees.c

  internal/glpk_support.c
  internal/hacks.c
  internal/lsap.c
  internal/qsort_r.c
  internal/qsort.c
  internal/utils.c
  internal/zeroin.c

  version.c

  # Vendored library sources. Yes, this is horrible.
  $<IF:$<OR:$<BOOL:${ARPACK_IS_VENDORED}>,$<BOOL:${BLAS_IS_VENDORED}>,$<BOOL:${LAPACK_IS_VENDORED}>>,$<TARGET_OBJECTS:f2c_vendored>,>
  $<IF:$<BOOL:${ARPACK_IS_VENDORED}>,$<TARGET_OBJECTS:arpack_vendored>,>
  $<IF:$<BOOL:${BLAS_IS_VENDORED}>,$<TARGET_OBJECTS:blas_vendored>,>
  $<IF:$<BOOL:${GLPK_IS_VENDORED}>,$<TARGET_OBJECTS:glpk_vendored>,>
  $<IF:$<BOOL:${GMP_IS_VENDORED}>,$<TARGET_OBJECTS:gmp_vendored>,>
  $<IF:$<BOOL:${LAPACK_IS_VENDORED}>,$<TARGET_OBJECTS:lapack_vendored>,>
  $<IF:$<BOOL:${PLFIT_IS_VENDORED}>,$<TARGET_OBJECTS:plfit_vendored>,>
)

# Required by Xcode new build system
add_dependencies(igraph parsersources)

# Set soname for the library
set_target_properties(igraph PROPERTIES VERSION "3.1.5")
set_target_properties(igraph PROPERTIES SOVERSION 3)

# Add extra compiler definitions if needed
target_compile_definitions(
  igraph
  PRIVATE
  IGRAPH_VERIFY_FINALLY_STACK=$<IF:$<BOOL:${IGRAPH_VERIFY_FINALLY_STACK}>,1,0>
)
# target_compile_options(
#   # -Wconversion could be useful?
#   igraph PRIVATE -Wshorten-64-to-32
# )

# Make sure that a macro named IGRAPH_FILE_BASENAME is provided in every
# compiler call so we can use these in debug messages without revealing the
# full path of the file on the machine where it was compiled
define_file_basename_for_sources(igraph)

# Add include path. Includes are in ../include but they get installed to
# <prefix>/include/igraph, hence the two options. We also have some private
# includes that are generated at compile time but are not part of the public
# interface.
target_include_directories(
  igraph
  PUBLIC
  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
  $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include>
  $<INSTALL_INTERFACE:include/igraph>
  PRIVATE
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${PROJECT_SOURCE_DIR}/vendor

  # Vendored library include paths
  "$<$<BOOL:${GLPK_IS_VENDORED}>:$<TARGET_PROPERTY:glpk_vendored,INCLUDE_DIRECTORIES>>"
  "$<$<BOOL:${PLFIT_IS_VENDORED}>:$<TARGET_PROPERTY:plfit_vendored,INCLUDE_DIRECTORIES>>"

  # Include paths for dependencies
  "$<$<BOOL:${GLPK_INCLUDE_DIR}>:${GLPK_INCLUDE_DIR}>"
  "$<$<BOOL:${GMP_INCLUDE_DIR}>:${GMP_INCLUDE_DIR}>"
  "$<$<BOOL:${LIBXML2_INCLUDE_DIRS}>:${LIBXML2_INCLUDE_DIRS}>"
  "$<$<BOOL:${PLFIT_INCLUDE_DIRS}>:${PLFIT_INCLUDE_DIRS}>"
)

if(MATH_LIBRARY)
  target_link_libraries(igraph PUBLIC ${MATH_LIBRARY})
endif()

if(ARPACK_LIBRARIES)
  target_link_libraries(igraph PRIVATE ${ARPACK_LIBRARIES})
endif()

if(BLAS_FOUND)
  target_link_libraries(igraph PRIVATE ${BLAS_LIBRARIES})
endif()

if(GLPK_LIBRARIES)
  target_link_libraries(igraph PRIVATE ${GLPK_LIBRARIES})
endif()

if(GMP_LIBRARIES)
  target_link_libraries(igraph PRIVATE ${GMP_LIBRARIES})
endif()

if(LAPACK_LIBRARIES)
  target_link_libraries(igraph PRIVATE ${LAPACK_LIBRARIES})
endif()

if(LIBXML2_LIBRARIES)
  target_link_libraries(igraph PRIVATE ${LIBXML2_LIBRARIES})
endif()

if(PLFIT_LIBRARIES)
  target_link_libraries(igraph PRIVATE ${PLFIT_LIBRARIES})
endif()

# Link igraph statically to some of the libraries from the subdirectories
target_link_libraries(
  igraph
  PRIVATE
  bliss cliquer cxsparse_vendored pcg prpack
)

if (NOT BUILD_SHARED_LIBS)
  target_compile_definitions(igraph PUBLIC IGRAPH_STATIC)
else()
  target_compile_definitions(igraph PRIVATE igraph_EXPORTS)
endif()

if(MSVC)
  # Add MSVC-specific include path for some headers that are missing on Windows
  target_include_directories(igraph PRIVATE ${PROJECT_SOURCE_DIR}/msvc/include)
endif()

# Turn on all warnings for GCC, clang and MSVC
use_all_warnings(igraph)

# GNUInstallDirs be included before generating the pkgconfig file, as it defines
# CMAKE_INSTALL_LIBDIR and CMAKE_INSTALL_INCLUDEDIR variables.
include(GNUInstallDirs)

# Generate pkgconfig file
include(pkgconfig_helpers)

include(GenerateExportHeader)
generate_export_header(igraph
  STATIC_DEFINE IGRAPH_STATIC
  EXPORT_FILE_NAME ${PROJECT_BINARY_DIR}/include/igraph_export.h
)

# Provide an igraph-config.cmake file in the installation directory so
# users can find the installed igraph library with FIND_PACKAGE(igraph)
# from their CMakeLists.txt files
include(CMakePackageConfigHelpers)
configure_package_config_file(
  ${PROJECT_SOURCE_DIR}/etc/cmake/igraph-config.cmake.in
  ${PROJECT_BINARY_DIR}/igraph-config.cmake
  # Install destination selected according to https://wiki.debian.org/CMake
  # and by looking at how eigen3 does it in Ubuntu
  INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/igraph
)
write_basic_package_version_file(
  ${PROJECT_BINARY_DIR}/igraph-config-version.cmake

=== debian/changelog ===
r-cran-igraph (2.0.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * dh-update-R to update Build-Depends (routine-update)
  * Refreshed the i386 patch.
  * d/control: build-dep on pkgconf, not pkg-config
  * d/copyright: updated to new package layout, added missing entries

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 28 Mar 2024 09:28:38 +0100

r-cran-igraph (2.0.1.1-1) unstable; urgency=medium

  * New upstream version
  * Build-Depends: libglpk-dev

 -- Andreas Tille <tille@debian.org>  Thu, 01 Feb 2024 16:51:57 +0100

=== debian/control ===
Source: r-cran-igraph
Maintainer: Debian R Packages Maintainers <r-pkg-team@alioth-lists.debian.net>
Uploaders: Andreas Tille <tille@debian.org>
Section: gnu-r
Testsuite: autopkgtest-pkg-r
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-r,
               r-base-dev,
               r-cran-cli,
               r-cran-lifecycle,
               r-cran-magrittr,
               r-cran-matrix,
               r-cran-pkgconfig,
               r-cran-rlang,
               r-cran-vctrs,
               r-cran-cpp11 (>= 0.4.7),
               libglpk-dev,
               libxml2-dev,
               pkgconf
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/r-pkg-team/r-cran-igraph
Vcs-Git: https://salsa.debian.org/r-pkg-team/r-cran-igraph.git
Homepage: https://cran.r-project.org/package=igraph
Rules-Requires-Root: no

Package: r-cran-igraph
Architecture: any
Depends: ${R:Depends},
         ${shlibs:Depends},
         ${misc:Depends}
Recommends: ${R:Recommends}
Suggests: ${R:Suggests}
Description: GNU R network analysis and visualization
 This GNU R package provides routines for simple graphs and network
 analysis. igraph can handle large graphs very well and provides
 functions for generating random and regular graphs, graph visualization,
 centrality indices and much more.

## r-cran-igraph 2.1.3

=== debian/changelog ===
r-cran-igraph (2.1.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Standards-Version: 4.7.0 (routine-update)
  * dh-update-R to update Build-Depends (routine-update)
  * d/control: no more pixmaps to install

 -- Michael R. Crusoe <crusoe@debian.org>  Sat, 18 Jan 2025 00:26:57 +0100

## r-cran-igraph 2.1.4

=== DESCRIPTION ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Package: igraph
-Version: 2.0.3
 Title: Network Analysis and Visualization
+Version: 2.1.4
 Authors@R: c(
     person("Gábor", "Csárdi", , "csardi.gabor@gmail.com", role = "aut",
            comment = c(ORCID = "0000-0001-7098-9676")),
@@ -30,12 +30,14 @@
 Depends: methods, R (>= 3.5.0)
 Imports: cli, graphics, grDevices, lifecycle, magrittr, Matrix,
         pkgconfig (>= 2.0.0), rlang, stats, utils, vctrs
-Suggests: ape (>= 5.7-0.1), callr, decor, digest, graph, igraphdata,
-        knitr, rgl, rmarkdown, scales, stats4, tcltk, testthat, vdiffr,
-        withr
-LinkingTo: cpp11 (>= 0.4.7)
+Suggests: ape (>= 5.7-0.1), callr, decor, digest, igraphdata, knitr,
+        rgl (>= 1.3.14), rmarkdown, scales, stats4, tcltk, testthat,
+        vdiffr, withr
+Enhances: graph
+LinkingTo: cpp11 (>= 0.5.0)
 VignetteBuilder: knitr
-Config/Needs/build: roxygen2, devtools, irlba, pkgconfig
+Config/Needs/build: roxygen2, devtools, irlba, pkgconfig,
+        igraph/igraph.r2cdocs, moodymudskipper/devtag
 Config/Needs/coverage: covr
 Config/Needs/website: readr
 Config/testthat/edition: 3
@@ -43,10 +45,10 @@
 Config/testthat/start-first: vs-es, scan, vs-operators, weakref,
         watts.strogatz.game
 Encoding: UTF-8
-RoxygenNote: 7.3.1
+RoxygenNote: 7.3.2.9000
 SystemRequirements: libxml2 (optional), glpk (>= 4.57, optional)
 NeedsCompilation: yes
-Packaged: 2024-03-12 18:19:12 UTC; kirill
+Packaged: 2025-01-22 19:28:33 UTC; kirill
 Author: Gábor Csárdi [aut] (<https://orcid.org/0000-0001-7098-9676>),
   Tamás Nepusz [aut] (<https://orcid.org/0000-0002-1451-338X>),
   Vincent Traag [aut] (<https://orcid.org/0000-0003-3170-3879>),
@@ -59,4 +61,4 @@
   Chan Zuckerberg Initiative [fnd]
 Maintainer: Kirill Müller <kirill@cynkra.com>
 Repository: CRAN
-Date/Publication: 2024-03-13 07:30:02 UTC
+Date/Publication: 2025-01-23 10:20:02 UTC

=== src/vendor/cigraph/src/CMakeLists.txt ===
--- 
+++ 
@@ -40,6 +40,8 @@
 add_library(
   igraph
   core/array.c
+  core/bitset.c
+  core/bitset_list.c
   core/buckets.c
   core/cutheap.c
   core/dqueue.c
@@ -113,6 +115,7 @@
 
   games/barabasi.c
   games/callaway_traits.c
+  games/chung_lu.c
   games/citations.c
   games/correlated.c
   games/degree_sequence_vl/gengraph_degree_sequence.cpp
@@ -177,6 +180,7 @@
   connectivity/cohesive_blocks.c
   connectivity/components.c
   connectivity/separators.c
+  connectivity/reachability.c
 
   flow/flow.c
   flow/flow_conversion.c
@@ -326,7 +330,7 @@
 add_dependencies(igraph parsersources)
 
 # Set soname for the library
-set_target_properties(igraph PROPERTIES VERSION "3.1.5")
+set_target_properties(igraph PROPERTIES VERSION "3.1.8")
 set_target_properties(igraph PROPERTIES SOVERSION 3)
 
 # Add extra compiler definitions if needed
@@ -448,5 +452,3 @@
   # and by looking at how eigen3 does it in Ubuntu
   INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/igraph
 )
-write_basic_package_version_file(
-  ${PROJECT_BINARY_DIR}/igraph-config-version.cmake

=== src/vendor/cigraph/vendor/cs/CMakeLists.txt ===
# Declare the files needed to compile our vendored CXSparse copy
add_library(
  cxsparse_vendored
  OBJECT
  EXCLUDE_FROM_ALL
  cs_add.c
  cs_amd.c
  cs_chol.c
  cs_cholsol.c
  cs_compress.c
  cs_counts.c
  cs_cumsum.c
  cs_dfs.c
  cs_dmperm.c
  cs_droptol.c
  cs_dropzeros.c
  cs_dupl.c
  cs_entry.c
  cs_ereach.c
  cs_etree.c
  cs_fkeep.c
  cs_gaxpy.c
  cs_happly.c
  cs_house.c
  cs_ipvec.c
  cs_leaf.c
  cs_load.c
  cs_lsolve.c
  cs_ltsolve.c
  cs_lu.c
  cs_lusol.c
  cs_malloc.c
  cs_maxtrans.c
  cs_multiply.c
  cs_norm.c
  cs_permute.c
  cs_pinv.c
  cs_post.c
  cs_pvec.c
  cs_qr.c
  cs_qrsol.c
  cs_randperm.c
  cs_reach.c
  cs_scatter.c
  cs_scc.c
  cs_schol.c
  cs_spsolve.c
  cs_sqr.c
  cs_symperm.c
  cs_tdfs.c
  cs_transpose.c
  cs_updown.c
  cs_usolve.c
  cs_util.c
  cs_utsolve.c
  # the following files are not needed - they contain no symbols
  # cs_print.c
)

target_include_directories(
  cxsparse_vendored
  PRIVATE
  ${PROJECT_SOURCE_DIR}/include
  ${PROJECT_BINARY_DIR}/include
)

if (BUILD_SHARED_LIBS)
  set_property(TARGET cxsparse_vendored PROPERTY POSITION_INDEPENDENT_CODE ON)
endif()

# Disable complex number support for CXSparse because:
#   - It is necessary to compile with MSVC
#   - igraph does not need complex number support from CXSparse on any platform
target_compile_definitions(cxsparse_vendored PUBLIC NCOMPLEX)

# Since these are included as object files, they should call the
# function as is (without a visibility specification)
target_compile_definitions(cxsparse_vendored PRIVATE IGRAPH_STATIC)

use_all_warnings(cxsparse_vendored)

if (MSVC)
  target_compile_options(
    cxsparse_vendored PRIVATE
    /wd4100
  ) # disable unreferenced parameter warning
else()
  target_compile_options(
    cxsparse_vendored PRIVATE
    $<$<C_COMPILER_ID:GCC,Clang,AppleClang,IntelLLVM>:-Wno-unused-variable>
  )
endif()

=== src/vendor/cigraph/vendor/f2c/CMakeLists.txt ===
# arith.h is built during compilation using arithchk.c
add_executable(arithchk EXCLUDE_FROM_ALL arithchk.c)
target_compile_definitions(arithchk PRIVATE NO_FPINIT)  # maybe also NO_LONG_LONG?
if (NOT MSVC)
  target_link_libraries(arithchk PRIVATE m)
endif()

# Provide an option for the user to provide an external arith.h for
# cross-compilation
set(
  F2C_EXTERNAL_ARITH_HEADER "" CACHE FILEPATH
  "Path to an external arith.h to use for compiling f2c, typically for cross-compilation"
)

if(F2C_EXTERNAL_ARITH_HEADER)
  configure_file(${F2C_EXTERNAL_ARITH_HEADER} arith.h COPYONLY)
else()
  if (CMAKE_CROSSCOMPILING AND NOT CMAKE_CROSSCOMPILING_EMULATOR)
    # Warn only, as in some circumstances, such as macOS with Rosetta,
    # arithchk can still be run through emulation and the build with not fail.
    message(WARNING 
      "Cross-compiling with internal ARPACK, BLAS or LAPACK, but "
      "F2C_EXTERNAL_ARITH_HEADER was not set and no cross-compiling "
      "emulator was provided in CMAKE_CROSSCOMPILING_EMULATOR either. "
      "The build is likely to fail. See igraph's installation instructions "
      "for more information.")
  endif()
  add_custom_command(
    OUTPUT arith.h
    COMMENT "Generating arith.h for f2c..."
    COMMAND arithchk > ${CMAKE_CURRENT_BINARY_DIR}/arith.h
    DEPENDS arithchk
    VERBATIM
  )
endif()

# Hidden CMake option for Szabolcs so he can collect arith.h headers from
# multiple systems in CI
option(IGRAPH_PRINT_ARITH_HEADER "Print the contents of the generated arith.h for debugging purposes")
mark_as_advanced(IGRAPH_PRINT_ARITH_HEADER)
if(IGRAPH_PRINT_ARITH_HEADER)
  add_custom_command(
    TARGET arithchk POST_BUILD
    COMMENT "Printing contents of arith.h..."
    COMMAND arithchk
    VERBATIM USES_TERMINAL
  )
endif()

# Declare the files needed to compile our vendored f2c copy
add_library(
  f2c_vendored
  OBJECT
  EXCLUDE_FROM_ALL
  abort_.c    dolio.c       r_sin.c
  dummy.c     dtime_.c      iio.c         r_sinh.c
  backspac.c      due.c     ilnw.c        r_sqrt.c
  c_abs.c     ef1asc_.c     inquire.c     r_tan.c
  c_cos.c     ef1cmc_.c     l_ge.c        r_tanh.c
  c_div.c     endfile.c     l_gt.c        rdfmt.c
  c_exp.c     erf_.c        l_le.c        rewind.c
  c_log.c     erfc_.c       l_lt.c        rsfe.c
  c_sin.c     err.c     lbitbits.c    rsli.c
  c_sqrt.c    etime_.c      lbitshft.c    rsne.c
  cabs.c      exit_.c       lread.c       s_cat.c
  close.c     f77_aloc.c    lwrite.c      s_cmp.c
  ctype.c     f77vers.c     s_copy.c
  d_abs.c     fmt.c     open.c        s_paus.c
  d_acos.c    fmtlib.c      pow_ci.c      s_rnge.c
  d_asin.c    ftell_.c      pow_dd.c      s_stop.c
  d_atan.c    pow_di.c      sfe.c
  d_atn2.c    getenv_.c     pow_hh.c      sig_die.c
  d_cnjg.c    h_abs.c       pow_ii.c      signal_.c
  d_cos.c     h_dim.c       pow_ri.c      signbit.c
  d_cosh.c    h_dnnt.c      pow_zi.c      sue.c
  d_dim.c     h_indx.c      pow_zz.c      system_.c
  d_exp.c     h_len.c       r_abs.c       typesize.c
  d_imag.c    h_mod.c       r_acos.c      uio.c
  d_int.c     h_nint.c      r_asin.c      uninit.c
  d_lg10.c    h_sign.c      r_atan.c      util.c
  d_log.c     hl_ge.c       r_atn2.c      wref.c
  d_mod.c     hl_gt.c       r_cnjg.c      wrtfmt.c
  d_nint.c    hl_le.c       r_cos.c       wsfe.c
  d_prod.c    hl_lt.c       r_cosh.c      wsle.c
  d_sign.c    i77vers.c     r_dim.c       wsne.c
  d_sin.c     i_abs.c       r_exp.c       xwsne.c
  d_sinh.c    i_dim.c       r_imag.c      z_abs.c
  d_sqrt.c    i_dnnt.c      r_int.c       z_cos.c
  d_tan.c     i_indx.c      r_lg10.c      z_div.c
  d_tanh.c    i_len.c       r_log.c       z_exp.c
  derf_.c     i_mod.c       r_mod.c       z_log.c
  derfc_.c    i_nint.c      r_nint.c      z_sin.c
  dfe.c   i_sign.c      r_sign.c      z_sqrt.c
  ${CMAKE_CURRENT_BINARY_DIR}/arith.h
)
target_include_directories(
  f2c_vendored
  PUBLIC
  ${PROJECT_SOURCE_DIR}/include
  ${PROJECT_BINARY_DIR}/include
  ${PROJECT_SOURCE_DIR}/src
  ${PROJECT_BINARY_DIR}/src
  PRIVATE
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
)

# Since these are included as object files, they should call the
# function as is (without visibility specification)
target_compile_definitions(f2c_vendored PRIVATE IGRAPH_STATIC)

if (WIN32)
  target_compile_definitions(f2c_vendored PRIVATE MSDOS)
endif()

if (MSVC)  
  target_include_directories(
    f2c_vendored
    PUBLIC
    ${PROJECT_SOURCE_DIR}/msvc/include
  )
endif()

if (BUILD_SHARED_LIBS)
  set_property(TARGET f2c_vendored PROPERTY POSITION_INDEPENDENT_CODE ON)
endif()

# Suppress some warnings that occur in the output because we do not want to
# mess around with the source of f2c too much to fix these
if(MSVC)
  target_compile_options(f2c_vendored PRIVATE
    /wd4005  # macro redefinition: f2c redefines max and min
    /wd4311  # pointer truncation; f2c does some magic with signals in signal_.c
  )
else()
  target_compile_options(arithchk PRIVATE 
    $<$<C_COMPILER_ID:GCC,Clang,AppleClang,IntelLLVM>:-Wno-format-zero-length>
  )
  target_compile_options(
    f2c_vendored PRIVATE 
    $<$<C_COMPILER_ID:GCC,Clang,AppleClang,IntelLLVM>:-Wno-parentheses -Wno-pointer-to-int-cast -Wno-implicit-function-declaration -Wno-format-zero-length>
    $<$<C_COMPILER_ID:Intel>:-Wno-parentheses -Wno-pointer-to-int-cast -Wno-implicit-function-declaration>
  )
endif()

=== src/vendor/cigraph/vendor/plfit/CMakeLists.txt ===
# Declare the files needed to compile our vendored plfit copy
add_library(
  plfit_vendored
  OBJECT
  EXCLUDE_FROM_ALL
  gss.c
  hzeta.c
  kolmogorov.c
  lbfgs.c
  mt.c
  options.c
  platform.c
  plfit.c
  plfit_error.c
  rbinom.c
  sampling.c
)

target_include_directories(
  plfit_vendored
  PRIVATE
  ${PROJECT_SOURCE_DIR}/include
  ${PROJECT_BINARY_DIR}/include
  PUBLIC
  ${CMAKE_CURRENT_SOURCE_DIR}
)

if (BUILD_SHARED_LIBS)
  set_property(TARGET plfit_vendored PROPERTY POSITION_INDEPENDENT_CODE ON)
endif()

# Since these are included as object files, they should call the
# function as is (without visibility specification)
target_compile_definitions(plfit_vendored PRIVATE IGRAPH_STATIC)

use_all_warnings(plfit_vendored)

if (MSVC)
  target_compile_options(
    plfit_vendored PRIVATE
    /wd4100
  ) # disable unreferenced parameter warning
endif()

if(IGRAPH_OPENMP_SUPPORT)
  target_link_libraries(plfit_vendored PRIVATE OpenMP::OpenMP_C)
endif()

=== debian/changelog ===
r-cran-igraph (2.1.4-1build1) questing; urgency=medium

  * No-change rebuild for libxml2 soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 20 May 2025 12:19:44 +0200

r-cran-igraph (2.1.4-1) unstable; urgency=medium

  * Team upload.
  * New upstream version

 -- Charles Plessy <plessy@debian.org>  Wed, 29 Jan 2025 16:54:57 +0900

=== debian/control ===
--- 
+++ 
@@ -14,11 +14,11 @@
                r-cran-pkgconfig,
                r-cran-rlang,
                r-cran-vctrs,
-               r-cran-cpp11 (>= 0.4.7),
+               r-cran-cpp11 (>= 0.5.0),
                libglpk-dev,
                libxml2-dev,
                pkgconf
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/r-pkg-team/r-cran-igraph
 Vcs-Git: https://salsa.debian.org/r-pkg-team/r-cran-igraph.git
 Homepage: https://cran.r-project.org/package=igraph

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_HARDENING=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/default.mk

%:
	dh $@ --buildsystem R

execute_after_dh_install:
	rm -f debian/$(DEB_SOURCE)/usr/lib/R/site-library/igraph/LICENSE
	rm -f debian/$(DEB_SOURCE)/usr/lib/R/site-library/igraph/html_library.license.terms
	#mkdir -p debian/$(DEB_SOURCE)/usr/share/pixmaps/igraph
	#mv debian/$(DEB_SOURCE)/usr/lib/R/site-library/igraph/*.gif debian/$(DEB_SOURCE)/usr/share/pixmaps/igraph/
	#mv debian/$(DEB_SOURCE)/usr/lib/R/site-library/igraph/tkigraph_help/*.gif debian/$(DEB_SOURCE)/usr/share/pixmaps/igraph/

## r-cran-igraph 2.2.1

=== debian/changelog ===
r-cran-igraph (2.2.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Standards-Version: 4.7.3 (routine-update)
  * Restrict to 64-bits architectures (routine-update)
  * Restrict to little-endian architectures (routine-update)
  * dh-update-R to update Build-Depends (routine-update)

 -- Charles Plessy <plessy@debian.org>  Fri, 26 Dec 2025 11:09:47 +0900

=== debian/control ===
--- 
+++ 
@@ -12,13 +12,15 @@
                r-cran-magrittr,
                r-cran-matrix,
                r-cran-pkgconfig,
-               r-cran-rlang,
+               r-cran-rlang (>= 1.1.0),
                r-cran-vctrs,
                r-cran-cpp11 (>= 0.5.0),
                libglpk-dev,
                libxml2-dev,
-               pkgconf
-Standards-Version: 4.7.0
+               pkgconf,
+               architecture-is-64-bit,
+               architecture-is-little-endian
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/r-pkg-team/r-cran-igraph
 Vcs-Git: https://salsa.debian.org/r-pkg-team/r-cran-igraph.git
 Homepage: https://cran.r-project.org/package=igraph

## r-cran-igraph 2.2.2

=== DESCRIPTION ===
Package: igraph
Title: Network Analysis and Visualization
Version: 2.2.2
Authors@R: c(
    person("Gábor", "Csárdi", , "csardi.gabor@gmail.com", role = "aut",
           comment = c(ORCID = "0000-0001-7098-9676")),
    person("Tamás", "Nepusz", , "ntamas@gmail.com", role = "aut",
           comment = c(ORCID = "0000-0002-1451-338X")),
    person("Vincent", "Traag", role = "aut",
           comment = c(ORCID = "0000-0003-3170-3879")),
    person("Szabolcs", "Horvát", , "szhorvat@gmail.com", role = "aut",
           comment = c(ORCID = "0000-0002-3100-523X")),
    person("Fabio", "Zanini", , "fabio.zanini@unsw.edu.au", role = "aut",
           comment = c(ORCID = "0000-0001-7097-8539")),
    person("Daniel", "Noom", role = "aut"),
    person("Kirill", "Müller", , "kirill@cynkra.com", role = c("aut", "cre"),
           comment = c(ORCID = "0000-0002-1416-3412")),
    person("Michael", "Antonov", role = "ctb"),
    person("Chan Zuckerberg Initiative", role = "fnd",
           comment = c(ROR = "02qenvm24")),
    person("David", "Schoch", , "david.schoch@cynkra.com", role = "aut",
           comment = c(ORCID = "0000-0003-2952-4812")),
    person("Maëlle", "Salmon", , "maelle@cynkra.com", role = "aut",
           comment = c(ORCID = "0000-0002-2815-0399"))
  )
Description: Routines for simple graphs and network analysis. It can
    handle large graphs very well and provides functions for generating
    random and regular graphs, graph visualization, centrality methods and
    much more.
License: GPL (>= 2)
URL: https://r.igraph.org/, https://igraph.org/,
        https://igraph.discourse.group/
BugReports: https://github.com/igraph/rigraph/issues
Depends: methods, R (>= 3.5.0)
Imports: cli, graphics, grDevices, lifecycle, magrittr, Matrix,
        pkgconfig (>= 2.0.0), rlang (>= 1.1.0), stats, utils, vctrs
Suggests: ape (>= 5.7-0.1), callr, decor, digest, igraphdata, knitr,
        rgl (>= 1.3.14), rmarkdown, scales, stats4, tcltk, testthat,
        vdiffr, withr
Enhances: graph
LinkingTo: cpp11 (>= 0.5.0)
VignetteBuilder: knitr
Config/build/compilation-database: false
Config/build/never-clean: true
Config/comment/compilation-database: Generate manually with
        pkgload:::generate_db() for faster pkgload::load_all()
Config/Needs/build: r-lib/roxygen2, devtools, irlba, pkgconfig,
        igraph/igraph.r2cdocs, moodymudskipper/devtag
Config/Needs/coverage: covr
Config/Needs/website: here, readr, tibble, xmlparsedata, xml2
Config/testthat/edition: 3
Config/testthat/parallel: true
Config/testthat/start-first: aaa-auto, vs-es, scan, vs-operators,
        weakref, watts.strogatz.game
Encoding: UTF-8
RoxygenNote: 7.3.3.9000
SystemRequirements: libxml2 (optional), glpk (>= 4.57, optional)
NeedsCompilation: yes
Packaged: 2026-02-12 09:58:29 UTC; kirill
Author: Gábor Csárdi [aut] (ORCID: <https://orcid.org/0000-0001-7098-9676>),
  Tamás Nepusz [aut] (ORCID: <https://orcid.org/0000-0002-1451-338X>),
  Vincent Traag [aut] (ORCID: <https://orcid.org/0000-0003-3170-3879>),
  Szabolcs Horvát [aut] (ORCID: <https://orcid.org/0000-0002-3100-523X>),
  Fabio Zanini [aut] (ORCID: <https://orcid.org/0000-0001-7097-8539>),
  Daniel Noom [aut],
  Kirill Müller [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-1416-3412>),
  Michael Antonov [ctb],
  Chan Zuckerberg Initiative [fnd] (ROR: <https://ror.org/02qenvm24>),
  David Schoch [aut] (ORCID: <https://orcid.org/0000-0003-2952-4812>),
  Maëlle Salmon [aut] (ORCID: <https://orcid.org/0000-0002-2815-0399>)
Maintainer: Kirill Müller <kirill@cynkra.com>
Repository: CRAN
Date/Publication: 2026-02-12 14:00:12 UTC

=== debian/changelog ===
r-cran-igraph (2.2.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Standards-Version: 4.7.3 (routine-update)
  * dh-update-R to update Build-Depends (routine-update)

 -- Charles Plessy <plessy@debian.org>  Tue, 17 Feb 2026 22:33:28 +0900

=== debian/control ===
Source: r-cran-igraph
Standards-Version: 4.7.3
Maintainer: Debian R Packages Maintainers <r-pkg-team@alioth-lists.debian.net>
Uploaders:
 Andreas Tille <tille@debian.org>,
Section: gnu-r
Testsuite: autopkgtest-pkg-r
Build-Depends:
 debhelper-compat (= 13),
 dh-r,
 r-base-dev,
 r-cran-cli,
 r-cran-lifecycle,
 r-cran-magrittr,
 r-cran-matrix,
 r-cran-pkgconfig,
 r-cran-rlang (>= 1.1.0),
 r-cran-vctrs,
 r-cran-cpp11 (>= 0.5.0),
 libglpk-dev,
 libxml2-dev,
 pkgconf,
 architecture-is-64-bit,
 architecture-is-little-endian,
Vcs-Browser: https://salsa.debian.org/r-pkg-team/r-cran-igraph
Vcs-Git: https://salsa.debian.org/r-pkg-team/r-cran-igraph.git
Homepage: https://cran.r-project.org/package=igraph
Rules-Requires-Root: no

Package: r-cran-igraph
Architecture: any
Depends:
 ${R:Depends},
 ${shlibs:Depends},
 ${misc:Depends},
Recommends:
 ${R:Recommends},
Suggests:
 ${R:Suggests},
Description: GNU R network analysis and visualization
 This GNU R package provides routines for simple graphs and network
 analysis. igraph can handle large graphs very well and provides
 functions for generating random and regular graphs, graph visualization,
 centrality indices and much more.

=== debian/tests/control ===
Tests: run-unit-test
Restrictions: allow-stderr
Depends:
 @,
 r-cran-ape (>= 5.7-0.1),
 r-cran-callr,
 r-cran-decor,
 r-cran-digest,
 r-cran-knitr,
 r-cran-rgl (>= 1.3.14),
 r-cran-rmarkdown,
 r-cran-scales,
 r-cran-testthat,
 r-cran-vdiffr,
 r-cran-withr,
